diff -Naur openssl-1.0.0q.orig/crypto/asn1/t_x509.c openssl-1.0.0q/crypto/asn1/t_x509.c
--- openssl-1.0.0q.orig/crypto/asn1/t_x509.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/t_x509.c	2017-04-25 16:23:40.000529114 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/buffer.h>
 #include <openssl/bn.h>
 #ifndef OPENSSL_NO_RSA
@@ -72,7 +74,9 @@
 #include <openssl/objects.h>
 #include <openssl/x509.h>
 #include <openssl/x509v3.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
+#ifndef OPERA_SMALL_VERSION
 #ifndef OPENSSL_NO_FP_API
 int X509_print_fp(FILE *fp, X509 *x)
 	{
@@ -244,7 +248,7 @@
 	unsigned char *dertmp;
 	int derlen;
 	int i;
-	unsigned char SHA1md[SHA_DIGEST_LENGTH];
+	unsigned char SHA1md[SHA_DIGEST_LENGTH]; /* ARRAY OK UNUSED 2009-05-25 yngve */
 
 	/* display the hash of the subject as it would appear
 	   in OCSP requests */
@@ -282,7 +286,9 @@
 	if (der != NULL) OPENSSL_free(der);
 	return(0);
 	}
+#endif
 
+#ifndef OPERA_SMALL_VERSION
 int X509_signature_print(BIO *bp, X509_ALGOR *sigalg, ASN1_STRING *sig)
 {
 	unsigned char *s;
@@ -302,6 +308,7 @@
 	if (BIO_write(bp,"\n",1) != 1) return 0;
 	return 1;
 }
+#endif
 
 int ASN1_STRING_print(BIO *bp, const ASN1_STRING *v)
 	{
@@ -342,11 +349,20 @@
 	return(0);
 }
 
-static const char *mon[12]=
-    {
-    "Jan","Feb","Mar","Apr","May","Jun",
-    "Jul","Aug","Sep","Oct","Nov","Dec"
-    };
+OPENSSL_PREFIX_CONST_ARRAY(static, const char*, asn1_mon,libopeay)
+	CONST_ENTRY("Jan")
+	CONST_ENTRY("Feb")
+	CONST_ENTRY("Mar")
+	CONST_ENTRY("Apr")
+	CONST_ENTRY("May")
+	CONST_ENTRY("Jun")
+	CONST_ENTRY("Jul")
+	CONST_ENTRY("Aug")
+	CONST_ENTRY("Sep")
+	CONST_ENTRY("Oct")
+	CONST_ENTRY("Nov")
+	CONST_ENTRY("Dec")
+CONST_END(asn1_mon)
 
 int ASN1_GENERALIZEDTIME_print(BIO *bp, const ASN1_GENERALIZEDTIME *tm)
 	{
@@ -387,7 +403,7 @@
 		}
 
 	if (BIO_printf(bp,"%s %2d %02d:%02d:%02d%.*s %d%s",
-		mon[M-1],d,h,m,s,f_len,f,y,(gmt)?" GMT":"") <= 0)
+		OPENSSL_GLOBAL_ARRAY_NAME(asn1_mon)[M-1],d,h,m,s,f_len,f,y,(gmt)?" GMT":"") <= 0)
 		return(0);
 	else
 		return(1);
@@ -423,7 +439,7 @@
 		s=  (v[10]-'0')*10+(v[11]-'0');
 
 	if (BIO_printf(bp,"%s %2d %02d:%02d:%02d %d%s",
-		mon[M-1],d,h,m,s,y+1900,(gmt)?" GMT":"") <= 0)
+		OPENSSL_GLOBAL_ARRAY_NAME(asn1_mon)[M-1],d,h,m,s,y+1900,(gmt)?" GMT":"") <= 0)
 		return(0);
 	else
 		return(1);
@@ -462,9 +478,9 @@
 			(*s == '\0'))
 #else
 		if (	((*s == '/') &&
-				(isupper(s[1]) && (
+				(op_isupper(s[1]) && (
 					(s[2] == '=') ||
-					(isupper(s[2]) &&
+					(op_isupper(s[2]) &&
 					(s[3] == '='))
 				 ))) ||
 			(*s == '\0'))
diff -Naur openssl-1.0.0q.orig/crypto/asn1/t_x509a.c openssl-1.0.0q/crypto/asn1/t_x509a.c
--- openssl-1.0.0q.orig/crypto/asn1/t_x509a.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/t_x509a.c	2017-04-25 16:23:40.002530207 +0200
@@ -56,8 +56,10 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/evp.h>
 #include <openssl/asn1.h>
 #include <openssl/x509.h>
@@ -65,6 +67,7 @@
 /* X509_CERT_AUX and string set routines
  */
 
+#ifndef OPERA_SMALL_VERSION
 int X509_CERT_AUX_print(BIO *out, X509_CERT_AUX *aux, int indent)
 {
 	char oidstr[80], first;
@@ -108,3 +111,4 @@
 	}
 	return 1;
 }
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/asn1/tasn_dec.c openssl-1.0.0q/crypto/asn1/tasn_dec.c
--- openssl-1.0.0q.orig/crypto/asn1/tasn_dec.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/tasn_dec.c	2017-04-25 16:23:40.005529191 +0200
@@ -57,8 +57,10 @@
  */
 
 
+#ifndef OPERA_SMALL_VERSION
 #include <stddef.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/asn1.h>
 #include <openssl/asn1t.h>
 #include <openssl/objects.h>
@@ -113,7 +115,12 @@
 
 /* Macro to initialize and invalidate the cache */
 
+#ifndef OPERA_SMALL_VERSION
 #define asn1_tlc_clear(c)	if (c) (c)->valid = 0
+#else
+inline void asn1_tlc_clear(ASN1_TLC *c) { if (c) c->valid = 0; }
+#endif // !OPERA_SMALL_VERSION
+
 /* Version to avoid compiler warning about 'c' always non-NULL */
 #define asn1_tlc_clear_nc(c)	(c)->valid = 0
 
@@ -138,6 +145,7 @@
 	return NULL;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int ASN1_template_d2i(ASN1_VALUE **pval,
 		const unsigned char **in, long len, const ASN1_TEMPLATE *tt)
 	{
@@ -145,6 +153,7 @@
 	asn1_tlc_clear_nc(&c);
 	return asn1_template_ex_d2i(pval, in, len, tt, 0, &c);
 	}
+#endif // !OPERA_SMALL_VERSION
 
 
 /* Decode an item, taking care of IMPLICIT tagging, if any.
@@ -158,7 +167,7 @@
 	const ASN1_TEMPLATE *tt, *errtt = NULL;
 	const ASN1_COMPAT_FUNCS *cf;
 	const ASN1_EXTERN_FUNCS *ef;
-	const ASN1_AUX *aux = it->funcs;
+	const ASN1_AUX *aux = (const ASN1_AUX *) it->funcs;
 	ASN1_aux_cb *asn1_cb;
 	const unsigned char *p = NULL, *q;
 	unsigned char *wp=NULL;	/* BIG FAT WARNING!  BREAKS CONST WHERE USED */
@@ -235,13 +244,13 @@
 
 		case ASN1_ITYPE_EXTERN:
 		/* Use new style d2i */
-		ef = it->funcs;
+		ef = (const ASN1_EXTERN_FUNCS *) it->funcs;
 		return ef->asn1_ex_d2i(pval, in, len,
 						it, tag, aclass, opt, ctx);
 
 		case ASN1_ITYPE_COMPAT:
 		/* we must resort to old style evil hackery */
-		cf = it->funcs;
+		cf = (const ASN1_COMPAT_FUNCS *) it->funcs;
 
 		/* If OPTIONAL see if it is there */
 		if (opt)
@@ -517,11 +526,16 @@
 	ASN1err(ASN1_F_ASN1_ITEM_EX_D2I, ASN1_R_AUX_ERROR);
 	err:
 	ASN1_item_ex_free(pval, it);
+#ifdef OPERA_SMALL_VERSION
+	// Suppress warning "variable set but not used".
+	(void) errtt;
+#else
 	if (errtt)
 		ERR_add_error_data(4, "Field=", errtt->field_name,
 					", Type=", it->sname);
 	else
 		ERR_add_error_data(2, "Type=", it->sname);
+#endif // OPERA_SMALL_VERSION
 	return 0;
 	}
 
@@ -781,6 +795,10 @@
 		return 0; /* Should never happen */
 		}
 
+	buf.data = NULL;
+	buf.length = 0;
+	buf.max = 0;
+
 	if (it->itype == ASN1_ITYPE_MSTRING)
 		{
 		utype = tag;
@@ -933,7 +951,7 @@
 	int ret = 0;
 	const ASN1_PRIMITIVE_FUNCS *pf;
 	ASN1_INTEGER **tint;
-	pf = it->funcs;
+	pf = (const ASN1_PRIMITIVE_FUNCS *) it->funcs;
 
 	if (pf && pf->prim_c2i)
 		return pf->prim_c2i(pval, cont, len, utype, free_cont, it);
@@ -1236,7 +1254,7 @@
 			ASN1err(ASN1_F_COLLECT_DATA, ERR_R_MALLOC_FAILURE);
 			return 0;
 			}
-		memcpy(buf->data + len, *p, plen);
+		op_memcpy(buf->data + len, *p, plen);
 		}
 	*p += plen;
 	return 1;
diff -Naur openssl-1.0.0q.orig/crypto/asn1/tasn_enc.c openssl-1.0.0q/crypto/asn1/tasn_enc.c
--- openssl-1.0.0q.orig/crypto/asn1/tasn_enc.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/tasn_enc.c	2017-04-25 16:23:40.006525407 +0200
@@ -57,9 +57,10 @@
  */
 
 
+#ifndef OPERA_SMALL_VERSION
 #include <stddef.h>
 #include <string.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/asn1.h>
 #include <openssl/asn1t.h>
 #include <openssl/objects.h>
@@ -80,11 +81,13 @@
  * to use indefinite length constructed encoding, where appropriate
  */
 
+#ifndef OPERA_SMALL_VERSION
 int ASN1_item_ndef_i2d(ASN1_VALUE *val, unsigned char **out,
 						const ASN1_ITEM *it)
 	{
 	return asn1_item_flags_i2d(val, out, it, ASN1_TFLG_NDEF);
 	}
+#endif
 
 int ASN1_item_i2d(ASN1_VALUE *val, unsigned char **out, const ASN1_ITEM *it)
 	{
@@ -110,7 +113,7 @@
 		len = ASN1_item_ex_i2d(&val, NULL, it, -1, flags);
 		if (len <= 0)
 			return len;
-		buf = OPENSSL_malloc(len);
+		buf = (unsigned char *) OPENSSL_malloc(len);
 		if (!buf)
 			return -1;
 		p = buf;
@@ -135,7 +138,7 @@
 	int i, seqcontlen, seqlen, ndef = 1;
 	const ASN1_COMPAT_FUNCS *cf;
 	const ASN1_EXTERN_FUNCS *ef;
-	const ASN1_AUX *aux = it->funcs;
+	const ASN1_AUX *aux = (const ASN1_AUX *) it->funcs;
 	ASN1_aux_cb *asn1_cb = 0;
 
 	if ((it->itype != ASN1_ITYPE_PRIMITIVE) && !*pval)
@@ -177,12 +180,12 @@
 
 		case ASN1_ITYPE_EXTERN:
 		/* If new style i2d it does all the work */
-		ef = it->funcs;
+		ef = (const ASN1_EXTERN_FUNCS *) it->funcs;
 		return ef->asn1_ex_i2d(pval, out, it, tag, aclass);
 
 		case ASN1_ITYPE_COMPAT:
 		/* old style hackery... */
-		cf = it->funcs;
+		cf = (const ASN1_COMPAT_FUNCS *) it->funcs;
 		if (out)
 			p = *out;
 		i = cf->asn1_i2d(*pval, out);
@@ -261,11 +264,13 @@
 	return 0;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int ASN1_template_i2d(ASN1_VALUE **pval, unsigned char **out,
 							const ASN1_TEMPLATE *tt)
 	{
 	return asn1_template_ex_i2d(pval, out, tt, -1, 0);
 	}
+#endif
 
 static int asn1_template_ex_i2d(ASN1_VALUE **pval, unsigned char **out,
 				const ASN1_TEMPLATE *tt, int tag, int iclass)
@@ -425,10 +430,10 @@
 
 static int der_cmp(const void *a, const void *b)
 	{
-	const DER_ENC *d1 = a, *d2 = b;
+	const DER_ENC *d1 = (const DER_ENC *) a, *d2 = (const DER_ENC *) b;
 	int cmplen, i;
 	cmplen = (d1->length < d2->length) ? d1->length : d2->length;
-	i = memcmp(d1->data, d2->data, cmplen);
+	i = op_memcmp(d1->data, d2->data, cmplen);
 	if (i)
 		return i;
 	return d1->length - d2->length;
@@ -451,16 +456,16 @@
 			do_sort = 0;
 		else
 			{
-			derlst = OPENSSL_malloc(sk_ASN1_VALUE_num(sk)
+			derlst = (DER_ENC *) OPENSSL_malloc(sk_ASN1_VALUE_num(sk)
 						* sizeof(*derlst));
-			if (!derlst)
-				return 0;
-			tmpdat = OPENSSL_malloc(skcontlen);
+			if(!derlst)
+ 				return 0;
+			tmpdat = (unsigned char *) OPENSSL_malloc(skcontlen);
 			if (!tmpdat)
-				{
+			{
 				OPENSSL_free(derlst);
 				return 0;
-				}
+			}
 			}
 		}
 	/* If not sorting just output each item */
@@ -485,12 +490,12 @@
 		}
 
 	/* Now sort them */
-	qsort(derlst, sk_ASN1_VALUE_num(sk), sizeof(*derlst), der_cmp);
+	op_qsort(derlst, sk_ASN1_VALUE_num(sk), sizeof(*derlst), der_cmp);
 	/* Output sorted DER encoding */	
 	p = *out;
 	for (i = 0, tder = derlst; i < sk_ASN1_VALUE_num(sk); i++, tder++)
 		{
-		memcpy(p, tder->data, tder->length);
+		op_memcpy(p, tder->data, tder->length);
 		p += tder->length;
 		}
 	*out = p;
@@ -578,7 +583,7 @@
 	unsigned char c;
 	int len;
 	const ASN1_PRIMITIVE_FUNCS *pf;
-	pf = it->funcs;
+	pf = (const ASN1_PRIMITIVE_FUNCS *) it->funcs;
 	if (pf && pf->prim_i2c)
 		return pf->prim_i2c(pval, cout, putype, it);
 
@@ -691,6 +696,6 @@
 
 		}
 	if (cout && len)
-		memcpy(cout, cont, len);
+		op_memcpy(cout, cont, len);
 	return len;
 	}
diff -Naur openssl-1.0.0q.orig/crypto/asn1/tasn_fre.c openssl-1.0.0q/crypto/asn1/tasn_fre.c
--- openssl-1.0.0q.orig/crypto/asn1/tasn_fre.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/tasn_fre.c	2017-04-25 16:23:40.007527490 +0200
@@ -57,7 +57,9 @@
  */
 
 
+#ifndef OPERA_SMALL_VERSION
 #include <stddef.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/asn1.h>
 #include <openssl/asn1t.h>
 #include <openssl/objects.h>
@@ -81,7 +83,7 @@
 	const ASN1_TEMPLATE *tt = NULL, *seqtt;
 	const ASN1_EXTERN_FUNCS *ef;
 	const ASN1_COMPAT_FUNCS *cf;
-	const ASN1_AUX *aux = it->funcs;
+	const ASN1_AUX *aux = (const ASN1_AUX *) it->funcs;
 	ASN1_aux_cb *asn1_cb;
 	int i;
 	if (!pval)
@@ -132,13 +134,13 @@
 		break;
 
 		case ASN1_ITYPE_COMPAT:
-		cf = it->funcs;
+		cf = (const ASN1_COMPAT_FUNCS *) it->funcs;
 		if (cf && cf->asn1_free)
 			cf->asn1_free(*pval);
 		break;
 
 		case ASN1_ITYPE_EXTERN:
-		ef = it->funcs;
+		ef = (const ASN1_EXTERN_FUNCS *) it->funcs;
 		if (ef && ef->asn1_ex_free)
 			ef->asn1_ex_free(pval, it);
 		break;
@@ -207,7 +209,7 @@
 	if (it)
 		{
 		const ASN1_PRIMITIVE_FUNCS *pf;
-		pf = it->funcs;
+		pf = (const ASN1_PRIMITIVE_FUNCS *) it->funcs;
 		if (pf && pf->prim_free)
 			{
 			pf->prim_free(pval, it);
diff -Naur openssl-1.0.0q.orig/crypto/asn1/tasn_new.c openssl-1.0.0q/crypto/asn1/tasn_new.c
--- openssl-1.0.0q.orig/crypto/asn1/tasn_new.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/tasn_new.c	2017-04-25 16:23:40.008527617 +0200
@@ -57,12 +57,16 @@
  */
 
 
+#ifndef OPERA_SMALL_VERSION
 #include <stddef.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/asn1.h>
 #include <openssl/objects.h>
 #include <openssl/err.h>
 #include <openssl/asn1t.h>
+#ifndef OPERA_SMALL_VERSION
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 static int asn1_item_ex_combine_new(ASN1_VALUE **pval, const ASN1_ITEM *it,
 								int combine);
@@ -91,7 +95,7 @@
 	const ASN1_TEMPLATE *tt = NULL;
 	const ASN1_COMPAT_FUNCS *cf;
 	const ASN1_EXTERN_FUNCS *ef;
-	const ASN1_AUX *aux = it->funcs;
+	const ASN1_AUX *aux = (const ASN1_AUX *) it->funcs;
 	ASN1_aux_cb *asn1_cb;
 	ASN1_VALUE **pseqval;
 	int i;
@@ -111,7 +115,7 @@
 		{
 
 		case ASN1_ITYPE_EXTERN:
-		ef = it->funcs;
+		ef = (const ASN1_EXTERN_FUNCS *) it->funcs;
 		if (ef && ef->asn1_ex_new)
 			{
 			if (!ef->asn1_ex_new(pval, it))
@@ -120,7 +124,7 @@
 		break;
 
 		case ASN1_ITYPE_COMPAT:
-		cf = it->funcs;
+		cf = (const ASN1_COMPAT_FUNCS *) it->funcs;
 		if (cf && cf->asn1_new) {
 			*pval = cf->asn1_new();
 			if (!*pval)
@@ -160,10 +164,10 @@
 			}
 		if (!combine)
 			{
-			*pval = OPENSSL_malloc(it->size);
+			*pval = (ASN1_VALUE *) OPENSSL_malloc(it->size);
 			if (!*pval)
 				goto memerr;
-			memset(*pval, 0, it->size);
+			op_memset(*pval, 0, it->size);
 			}
 		asn1_set_choice_selector(pval, -1, it);
 		if (asn1_cb && !asn1_cb(ASN1_OP_NEW_POST, pval, it, NULL))
@@ -188,10 +192,10 @@
 			}
 		if (!combine)
 			{
-			*pval = OPENSSL_malloc(it->size);
+			*pval = (ASN1_VALUE *) OPENSSL_malloc(it->size);
 			if (!*pval)
 				goto memerr;
-			memset(*pval, 0, it->size);
+			op_memset(*pval, 0, it->size);
 			asn1_do_lock(pval, 0, it);
 			asn1_enc_init(pval, it);
 			}
@@ -235,7 +239,7 @@
 		{
 
 		case ASN1_ITYPE_EXTERN:
-		ef = it->funcs;
+		ef = (const ASN1_EXTERN_FUNCS *) it->funcs;
 		if (ef && ef->asn1_ex_clear) 
 			ef->asn1_ex_clear(pval, it);
 		else *pval = NULL;
@@ -330,9 +334,9 @@
 
 	if (it && it->funcs)
 		{
-		const ASN1_PRIMITIVE_FUNCS *pf = it->funcs;
+		const ASN1_PRIMITIVE_FUNCS *pf = (const ASN1_PRIMITIVE_FUNCS *) it->funcs;
 		if (pf->prim_new)
-			return pf->prim_new(pval, it);
+		return pf->prim_new(pval, it);
 		}
 
 	if (!it || (it->itype == ASN1_ITYPE_MSTRING))
@@ -354,7 +358,7 @@
 		return 1;
 
 		case V_ASN1_ANY:
-		typ = OPENSSL_malloc(sizeof(ASN1_TYPE));
+		typ = (ASN1_TYPE *) OPENSSL_malloc(sizeof(ASN1_TYPE));
 		if (!typ)
 			return 0;
 		typ->value.ptr = NULL;
@@ -379,7 +383,7 @@
 	int utype;
 	if (it && it->funcs)
 		{
-		const ASN1_PRIMITIVE_FUNCS *pf = it->funcs;
+		const ASN1_PRIMITIVE_FUNCS *pf = (const ASN1_PRIMITIVE_FUNCS *) it->funcs;
 		if (pf->prim_clear)
 			pf->prim_clear(pval, it);
 		else 
diff -Naur openssl-1.0.0q.orig/crypto/asn1/tasn_prn.c openssl-1.0.0q/crypto/asn1/tasn_prn.c
--- openssl-1.0.0q.orig/crypto/asn1/tasn_prn.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/tasn_prn.c	2017-04-25 16:23:40.009526347 +0200
@@ -57,8 +57,10 @@
  */
 
 
+#ifndef OPERA_SMALL_VERSION
 #include <stddef.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1.h>
 #include <openssl/asn1t.h>
 #include <openssl/objects.h>
diff -Naur openssl-1.0.0q.orig/crypto/asn1/tasn_typ.c openssl-1.0.0q/crypto/asn1/tasn_typ.c
--- openssl-1.0.0q.orig/crypto/asn1/tasn_typ.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/tasn_typ.c	2017-04-25 16:23:40.010526474 +0200
@@ -55,9 +55,13 @@
  * Hudson (tjh@cryptsoft.com).
  *
  */
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1.h>
 #include <openssl/asn1t.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 /* Declarations for string types */
 
@@ -75,39 +79,59 @@
 IMPLEMENT_ASN1_FUNCTIONS(ASN1_OCTET_STRING)
 
 IMPLEMENT_ASN1_TYPE(ASN1_NULL)
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(ASN1_NULL)
+#endif
 
 IMPLEMENT_ASN1_TYPE(ASN1_OBJECT)
 
 IMPLEMENT_ASN1_TYPE(ASN1_UTF8STRING)
-IMPLEMENT_ASN1_FUNCTIONS(ASN1_UTF8STRING)
+#ifdef LIBOPEAY_PKCS12_SUPPORT
+IMPLEMENT_ASN1_FUNCTIONS3(ASN1_UTF8STRING)
+#endif
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_TYPE(ASN1_PRINTABLESTRING)
 IMPLEMENT_ASN1_FUNCTIONS(ASN1_PRINTABLESTRING)
+#endif
 
 IMPLEMENT_ASN1_TYPE(ASN1_T61STRING)
-IMPLEMENT_ASN1_FUNCTIONS(ASN1_T61STRING)
+#ifdef LIBOPEAY_ASYNCHRONOUS_KEYGENERATION
+IMPLEMENT_ASN1_FUNCTIONS31(ASN1_T61STRING)
+#endif
 
 IMPLEMENT_ASN1_TYPE(ASN1_IA5STRING)
-IMPLEMENT_ASN1_FUNCTIONS(ASN1_IA5STRING)
+IMPLEMENT_ASN1_FUNCTIONS3(ASN1_IA5STRING)
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_TYPE(ASN1_GENERALSTRING)
 IMPLEMENT_ASN1_FUNCTIONS(ASN1_GENERALSTRING)
+#endif
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_TYPE(ASN1_UTCTIME)
 IMPLEMENT_ASN1_FUNCTIONS(ASN1_UTCTIME)
+#endif
 
 IMPLEMENT_ASN1_TYPE(ASN1_GENERALIZEDTIME)
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(ASN1_GENERALIZEDTIME)
+#endif
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_TYPE(ASN1_VISIBLESTRING)
 IMPLEMENT_ASN1_FUNCTIONS(ASN1_VISIBLESTRING)
+#endif
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_TYPE(ASN1_UNIVERSALSTRING)
 IMPLEMENT_ASN1_FUNCTIONS(ASN1_UNIVERSALSTRING)
+#endif
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_TYPE(ASN1_BMPSTRING)
 IMPLEMENT_ASN1_FUNCTIONS(ASN1_BMPSTRING)
+#endif
 
 IMPLEMENT_ASN1_TYPE(ASN1_ANY)
 
@@ -119,28 +143,36 @@
 /* Multistring types */
 
 IMPLEMENT_ASN1_MSTRING(ASN1_PRINTABLE, B_ASN1_PRINTABLE)
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS_name(ASN1_STRING, ASN1_PRINTABLE)
+#endif
 
 IMPLEMENT_ASN1_MSTRING(DISPLAYTEXT, B_ASN1_DISPLAYTEXT)
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS_name(ASN1_STRING, DISPLAYTEXT)
+#endif
 
 IMPLEMENT_ASN1_MSTRING(DIRECTORYSTRING, B_ASN1_DIRECTORYSTRING)
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS_name(ASN1_STRING, DIRECTORYSTRING)
+#endif
 
 /* Three separate BOOLEAN type: normal, DEFAULT TRUE and DEFAULT FALSE */
 IMPLEMENT_ASN1_TYPE_ex(ASN1_BOOLEAN, ASN1_BOOLEAN, -1)
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_TYPE_ex(ASN1_TBOOLEAN, ASN1_BOOLEAN, 1)
+#endif
 IMPLEMENT_ASN1_TYPE_ex(ASN1_FBOOLEAN, ASN1_BOOLEAN, 0)
 
 /* Special, OCTET STRING with indefinite length constructed support */
 
 IMPLEMENT_ASN1_TYPE_ex(ASN1_OCTET_STRING_NDEF, ASN1_OCTET_STRING, ASN1_TFLG_NDEF)
 
-ASN1_ITEM_TEMPLATE(ASN1_SEQUENCE_ANY) = 
+ASN1_ITEM_TEMPLATE(ASN1_SEQUENCE_ANY)
 	ASN1_EX_TEMPLATE_TYPE(ASN1_TFLG_SEQUENCE_OF, 0, ASN1_SEQUENCE_ANY, ASN1_ANY)
 ASN1_ITEM_TEMPLATE_END(ASN1_SEQUENCE_ANY)
 
-ASN1_ITEM_TEMPLATE(ASN1_SET_ANY) = 
+ASN1_ITEM_TEMPLATE(ASN1_SET_ANY)
 	ASN1_EX_TEMPLATE_TYPE(ASN1_TFLG_SET_OF, 0, ASN1_SET_ANY, ASN1_ANY)
 ASN1_ITEM_TEMPLATE_END(ASN1_SET_ANY)
 
diff -Naur openssl-1.0.0q.orig/crypto/asn1/tasn_utl.c openssl-1.0.0q/crypto/asn1/tasn_utl.c
--- openssl-1.0.0q.orig/crypto/asn1/tasn_utl.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/tasn_utl.c	2017-04-25 16:23:40.011526601 +0200
@@ -57,8 +57,10 @@
  */
 
 
+#ifndef OPERA_SMALL_VERSION
 #include <stddef.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/asn1.h>
 #include <openssl/asn1t.h>
 #include <openssl/objects.h>
@@ -75,7 +77,7 @@
 
 int asn1_get_choice_selector(ASN1_VALUE **pval, const ASN1_ITEM *it)
 	{
-	int *sel = offset2ptr(*pval, it->utype);
+	int *sel = (int *) offset2ptr(*pval, it->utype);
 	return *sel;
 	}
 
@@ -86,7 +88,7 @@
 int asn1_set_choice_selector(ASN1_VALUE **pval, int value, const ASN1_ITEM *it)
 	{	
 	int *sel, ret;
-	sel = offset2ptr(*pval, it->utype);
+	sel = (int *) offset2ptr(*pval, it->utype);
 	ret = *sel;
 	*sel = value;
 	return ret;
@@ -105,10 +107,10 @@
 	if ((it->itype != ASN1_ITYPE_SEQUENCE)
 	   && (it->itype != ASN1_ITYPE_NDEF_SEQUENCE))
 		return 0;
-	aux = it->funcs;
+	aux = (const ASN1_AUX *) it->funcs;
 	if (!aux || !(aux->flags & ASN1_AFLG_REFCOUNT))
 		return 0;
-	lck = offset2ptr(*pval, aux->ref_offset);
+	lck = (int *) offset2ptr(*pval, aux->ref_offset);
 	if (op == 0)
 		{
 		*lck = 1;
@@ -130,10 +132,10 @@
 	const ASN1_AUX *aux;
 	if (!pval || !*pval)
 		return NULL;
-	aux = it->funcs;
+	aux = (const ASN1_AUX *) it->funcs;
 	if (!aux || !(aux->flags & ASN1_AFLG_ENCODING))
 		return NULL;
-	return offset2ptr(*pval, aux->enc_offset);
+	return (ASN1_ENCODING *) offset2ptr(*pval, aux->enc_offset);
 	}
 
 void asn1_enc_init(ASN1_VALUE **pval, const ASN1_ITEM *it)
@@ -172,10 +174,10 @@
 
 	if (enc->enc)
 		OPENSSL_free(enc->enc);
-	enc->enc = OPENSSL_malloc(inlen);
+	enc->enc = (unsigned char *) OPENSSL_malloc(inlen);
 	if (!enc->enc)
 		return 0;
-	memcpy(enc->enc, in, inlen);
+	op_memcpy(enc->enc, in, inlen);
 	enc->len = inlen;
 	enc->modified = 0;
 
@@ -191,7 +193,7 @@
 		return 0;
 	if (out)
 		{
-		memcpy(*out, enc->enc, enc->len);
+		op_memcpy(*out, enc->enc, enc->len);
 		*out += enc->len;
 		}
 	if (len)
@@ -205,7 +207,7 @@
 	ASN1_VALUE **pvaltmp;
 	if (tt->flags & ASN1_TFLG_COMBINE)
 		return pval;
-	pvaltmp = offset2ptr(*pval, tt->offset);
+	pvaltmp = (ASN1_VALUE **) offset2ptr(*pval, tt->offset);
 	/* NOTE for BOOLEAN types the field is just a plain
  	 * int so we can't return int **, so settle for
 	 * (int *).
@@ -232,7 +234,7 @@
 	adb = ASN1_ADB_ptr(tt->item);
 
 	/* Get the selector field */
-	sfld = offset2ptr(*pval, adb->offset);
+	sfld = (ASN1_VALUE **) offset2ptr(*pval, adb->offset);
 
 	/* Check if NULL */
 	if (!sfld)
diff -Naur openssl-1.0.0q.orig/crypto/asn1/x_algor.c openssl-1.0.0q/crypto/asn1/x_algor.c
--- openssl-1.0.0q.orig/crypto/asn1/x_algor.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/x_algor.c	2017-04-25 16:23:40.012525890 +0200
@@ -56,23 +56,31 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stddef.h>
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/x509.h>
 #include <openssl/asn1.h>
 #include <openssl/asn1t.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
-ASN1_SEQUENCE(X509_ALGOR) = {
-	ASN1_SIMPLE(X509_ALGOR, algorithm, ASN1_OBJECT),
+ASN1_SEQUENCE(X509_ALGOR)
+	ASN1_SIMPLE(X509_ALGOR, algorithm, ASN1_OBJECT)
 	ASN1_OPT(X509_ALGOR, parameter, ASN1_ANY)
-} ASN1_SEQUENCE_END(X509_ALGOR)
+ASN1_SEQUENCE_END(X509_ALGOR)
 
-ASN1_ITEM_TEMPLATE(X509_ALGORS) = 
+ASN1_ITEM_TEMPLATE(X509_ALGORS)
 	ASN1_EX_TEMPLATE_TYPE(ASN1_TFLG_SEQUENCE_OF, 0, algorithms, X509_ALGOR)
 ASN1_ITEM_TEMPLATE_END(X509_ALGORS)
 
 IMPLEMENT_ASN1_FUNCTIONS(X509_ALGOR)
+
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_ENCODE_FUNCTIONS_fname(X509_ALGORS, X509_ALGORS, X509_ALGORS)
 IMPLEMENT_ASN1_DUP_FUNCTION(X509_ALGOR)
+#endif
 
 IMPLEMENT_STACK_OF(X509_ALGOR)
 IMPLEMENT_ASN1_SET_OF(X509_ALGOR)
diff -Naur openssl-1.0.0q.orig/crypto/asn1/x_attrib.c openssl-1.0.0q/crypto/asn1/x_attrib.c
--- openssl-1.0.0q.orig/crypto/asn1/x_attrib.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/x_attrib.c	2017-04-25 16:23:40.013526576 +0200
@@ -56,11 +56,14 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/objects.h>
 #include <openssl/asn1t.h>
 #include <openssl/x509.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 /* X509_ATTRIBUTE: this has the following form:
  *
@@ -82,18 +85,18 @@
  * SET OF structure.
  */
 
-ASN1_CHOICE(X509_ATTRIBUTE_SET) = {
-	ASN1_SET_OF(X509_ATTRIBUTE, value.set, ASN1_ANY),
+ASN1_CHOICE(X509_ATTRIBUTE_SET)
+	ASN1_SET_OF(X509_ATTRIBUTE, value.set, ASN1_ANY)
 	ASN1_SIMPLE(X509_ATTRIBUTE, value.single, ASN1_ANY)
-} ASN1_CHOICE_END_selector(X509_ATTRIBUTE, X509_ATTRIBUTE_SET, single)
+ASN1_CHOICE_END_selector(X509_ATTRIBUTE, X509_ATTRIBUTE_SET, single)
 
-ASN1_SEQUENCE(X509_ATTRIBUTE) = {
-	ASN1_SIMPLE(X509_ATTRIBUTE, object, ASN1_OBJECT),
+ASN1_SEQUENCE(X509_ATTRIBUTE)
+	ASN1_SIMPLE(X509_ATTRIBUTE, object, ASN1_OBJECT)
 	/* CHOICE type merged with parent */
 	ASN1_EX_COMBINE(0, 0, X509_ATTRIBUTE_SET)
-} ASN1_SEQUENCE_END(X509_ATTRIBUTE)
+ASN1_SEQUENCE_END(X509_ATTRIBUTE)
 
-IMPLEMENT_ASN1_FUNCTIONS(X509_ATTRIBUTE)
+IMPLEMENT_ASN1_FUNCTIONS3(X509_ATTRIBUTE)
 IMPLEMENT_ASN1_DUP_FUNCTION(X509_ATTRIBUTE)
 
 X509_ATTRIBUTE *X509_ATTRIBUTE_create(int nid, int atrtype, void *value)
diff -Naur openssl-1.0.0q.orig/crypto/asn1/x_bignum.c openssl-1.0.0q/crypto/asn1/x_bignum.c
--- openssl-1.0.0q.orig/crypto/asn1/x_bignum.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/x_bignum.c	2017-04-25 16:23:40.014526703 +0200
@@ -56,10 +56,13 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1t.h>
 #include <openssl/bn.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 /* Custom primitive type for BIGNUM handling. This reads in an ASN1_INTEGER as a
  * BIGNUM directly. Currently it ignores the sign which isn't a problem since all
@@ -75,22 +78,22 @@
 static int bn_i2c(ASN1_VALUE **pval, unsigned char *cont, int *putype, const ASN1_ITEM *it);
 static int bn_c2i(ASN1_VALUE **pval, const unsigned char *cont, int len, int utype, char *free_cont, const ASN1_ITEM *it);
 
-static ASN1_PRIMITIVE_FUNCS bignum_pf = {
-	NULL, 0,
-	bn_new,
-	bn_free,
-	0,
-	bn_c2i,
-	bn_i2c
-};
-
-ASN1_ITEM_start(BIGNUM)
-	ASN1_ITYPE_PRIMITIVE, V_ASN1_INTEGER, NULL, 0, &bignum_pf, 0, "BIGNUM"
-ASN1_ITEM_end(BIGNUM)
-
-ASN1_ITEM_start(CBIGNUM)
-	ASN1_ITYPE_PRIMITIVE, V_ASN1_INTEGER, NULL, 0, &bignum_pf, BN_SENSITIVE, "BIGNUM"
-ASN1_ITEM_end(CBIGNUM)
+OPENSSL_PREFIX_CONST_ITEM(static, ASN1_PRIMITIVE_FUNCS, bignum_pf, libopeay)
+	CONST_ITEM_ENTRY_START(app_data, NULL)
+	CONST_ITEM_ENTRY_SINGLE(flags, 0)
+	CONST_ITEM_ENTRY_SINGLE(prim_new, bn_new)
+	CONST_ITEM_ENTRY_SINGLE(prim_free, bn_free)
+	CONST_ITEM_ENTRY_SINGLE(prim_clear, NULL)
+	CONST_ITEM_ENTRY_SINGLE(prim_c2i, bn_c2i)
+	CONST_ITEM_ENTRY_SINGLE(prim_i2c, bn_i2c)
+	CONST_ITEM_ENTRY_SINGLE(prim_print, NULL)
+CONST_ITEM_ENTRY_END
+
+ASN1_ITEM_TEMPLATE_BLOCK(BIGNUM,
+	ASN1_ITYPE_PRIMITIVE, V_ASN1_INTEGER, NULL, 0, &OPENSSL_GLOBAL_ITEM_NAME(bignum_pf), 0)
+
+ASN1_ITEM_TEMPLATE_BLOCK(CBIGNUM,
+	ASN1_ITYPE_PRIMITIVE, V_ASN1_INTEGER, NULL, 0, &OPENSSL_GLOBAL_ITEM_NAME(bignum_pf), BN_SENSITIVE)
 
 static int bn_new(ASN1_VALUE **pval, const ASN1_ITEM *it)
 {
diff -Naur openssl-1.0.0q.orig/crypto/asn1/x_crl.c openssl-1.0.0q/crypto/asn1/x_crl.c
--- openssl-1.0.0q.orig/crypto/asn1/x_crl.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/asn1/x_crl.c	2017-04-25 16:23:40.015527948 +0200
@@ -56,36 +56,42 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include "asn1_locl.h"
 #include <openssl/asn1t.h>
 #include <openssl/x509.h>
 #include <openssl/x509v3.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 static int X509_REVOKED_cmp(const X509_REVOKED * const *a,
 				const X509_REVOKED * const *b);
 static void setup_idp(X509_CRL *crl, ISSUING_DIST_POINT *idp);
 
-ASN1_SEQUENCE(X509_REVOKED) = {
-	ASN1_SIMPLE(X509_REVOKED,serialNumber, ASN1_INTEGER),
-	ASN1_SIMPLE(X509_REVOKED,revocationDate, ASN1_TIME),
+ASN1_SEQUENCE(X509_REVOKED)
+	ASN1_SIMPLE(X509_REVOKED,serialNumber, ASN1_INTEGER)
+	ASN1_SIMPLE(X509_REVOKED,revocationDate, ASN1_TIME)
 	ASN1_SEQUENCE_OF_OPT(X509_REVOKED,extensions, X509_EXTENSION)
-} ASN1_SEQUENCE_END(X509_REVOKED)
+ASN1_SEQUENCE_END(X509_REVOKED)
 
 static int def_crl_verify(X509_CRL *crl, EVP_PKEY *r);
 static int def_crl_lookup(X509_CRL *crl,
 		X509_REVOKED **ret, ASN1_INTEGER *serial, X509_NAME *issuer);
 
-static X509_CRL_METHOD int_crl_meth =
-	{
+CONST_X509_CRL_METHOD_ITEM(x_crl__int_crl_meth,
 	0,
 	0,0,
 	def_crl_lookup,
 	def_crl_verify
-	};
+	);
+#define int_crl_meth OPENSSL_GLOBAL_ITEM_NAME(x_crl__int_crl_meth)
+
+OPENSSL_IMPLEMENT_GLOBAL(const X509_CRL_METHOD *, x_crl__default_crl_method);
+#define default_crl_method OPENSSL_GLOBAL_REF(x_crl__default_crl_method)
+
 
-static const X509_CRL_METHOD *default_crl_method = &int_crl_meth;
 
 /* The X509_CRL_INFO structure needs a bit of customisation.
  * Since we cache the original encoding the signature wont be affected by
@@ -109,15 +115,15 @@
 }
 
 
-ASN1_SEQUENCE_enc(X509_CRL_INFO, enc, crl_inf_cb) = {
-	ASN1_OPT(X509_CRL_INFO, version, ASN1_INTEGER),
-	ASN1_SIMPLE(X509_CRL_INFO, sig_alg, X509_ALGOR),
-	ASN1_SIMPLE(X509_CRL_INFO, issuer, X509_NAME),
-	ASN1_SIMPLE(X509_CRL_INFO, lastUpdate, ASN1_TIME),
-	ASN1_OPT(X509_CRL_INFO, nextUpdate, ASN1_TIME),
-	ASN1_SEQUENCE_OF_OPT(X509_CRL_INFO, revoked, X509_REVOKED),
+ASN1_SEQUENCE_enc(X509_CRL_INFO, enc, crl_inf_cb)
+	ASN1_OPT(X509_CRL_INFO, version, ASN1_INTEGER)
+	ASN1_SIMPLE(X509_CRL_INFO, sig_alg, X509_ALGOR)
+	ASN1_SIMPLE(X509_CRL_INFO, issuer, X509_NAME)
+	ASN1_SIMPLE(X509_CRL_INFO, lastUpdate, ASN1_TIME)
+	ASN1_OPT(X509_CRL_INFO, nextUpdate, ASN1_TIME)
+	ASN1_SEQUENCE_OF_OPT(X509_CRL_INFO, revoked, X509_REVOKED)
 	ASN1_EXP_SEQUENCE_OF_OPT(X509_CRL_INFO, extensions, X509_EXTENSION, 0)
-} ASN1_SEQUENCE_END_enc(X509_CRL_INFO, X509_CRL_INFO)
+ASN1_SEQUENCE_END_enc(X509_CRL_INFO, X509_CRL_INFO)
 
 /* Set CRL entry issuer according to CRL certificate issuer extension.
  * Check for unhandled critical CRL entry extensions.
@@ -139,7 +145,7 @@
 		STACK_OF(X509_EXTENSION) *exts;
 		ASN1_ENUMERATED *reason;
 		X509_EXTENSION *ext;
-		gtmp = X509_REVOKED_get_ext_d2i(rev, 
+		gtmp = (GENERAL_NAMES *) X509_REVOKED_get_ext_d2i(rev,
 						NID_certificate_issuer,
 						&j, NULL);
 		if (!gtmp && (j != -1))
@@ -162,7 +168,7 @@
 			}
 		rev->issuer = gens;
 
-		reason = X509_REVOKED_get_ext_d2i(rev, NID_crl_reason,
+		reason = (ASN1_ENUMERATED *) X509_REVOKED_get_ext_d2i(rev, NID_crl_reason,
 								&j, NULL);
 		if (!reason && (j != -1))
 			{
@@ -232,18 +238,18 @@
 #ifndef OPENSSL_NO_SHA
 		X509_CRL_digest(crl, EVP_sha1(), crl->sha1_hash, NULL);
 #endif
-		crl->idp = X509_CRL_get_ext_d2i(crl,
+		crl->idp = (ISSUING_DIST_POINT *) X509_CRL_get_ext_d2i(crl,
 				NID_issuing_distribution_point, NULL, NULL);
 		if (crl->idp)
 			setup_idp(crl, crl->idp);
 
-		crl->akid = X509_CRL_get_ext_d2i(crl,
+		crl->akid = (AUTHORITY_KEYID *) X509_CRL_get_ext_d2i(crl,
 				NID_authority_key_identifier, NULL, NULL);	
 
-		crl->crl_number = X509_CRL_get_ext_d2i(crl,
+		crl->crl_number = (ASN1_INTEGER *) X509_CRL_get_ext_d2i(crl,
 				NID_crl_number, NULL, NULL);	
 
-		crl->base_crl_number = X509_CRL_get_ext_d2i(crl,
+		crl->base_crl_number = (ASN1_INTEGER *) X509_CRL_get_ext_d2i(crl,
 				NID_delta_crl, NULL, NULL);	
 		/* Delta CRLs must have CRL number */
 		if (crl->base_crl_number && !crl->crl_number)
@@ -350,11 +356,11 @@
 	DIST_POINT_set_dpname(idp->distpoint, X509_CRL_get_issuer(crl));
 	}
 
-ASN1_SEQUENCE_ref(X509_CRL, crl_cb, CRYPTO_LOCK_X509_CRL) = {
-	ASN1_SIMPLE(X509_CRL, crl, X509_CRL_INFO),
-	ASN1_SIMPLE(X509_CRL, sig_alg, X509_ALGOR),
+ASN1_SEQUENCE_ref(X509_CRL, crl_cb, CRYPTO_LOCK_X509_CRL)
+	ASN1_SIMPLE(X509_CRL, crl, X509_CRL_INFO)
+	ASN1_SIMPLE(X509_CRL, sig_alg, X509_ALGOR)
 	ASN1_SIMPLE(X509_CRL, signature, ASN1_BIT_STRING)
-} ASN1_SEQUENCE_END_ref(X509_CRL, X509_CRL)
+ASN1_SEQUENCE_END_ref(X509_CRL, X509_CRL)
 
 IMPLEMENT_ASN1_FUNCTIONS(X509_REVOKED)
 IMPLEMENT_ASN1_FUNCTIONS(X509_CRL_INFO)
@@ -494,7 +500,7 @@
 	int (*crl_verify)(X509_CRL *crl, EVP_PKEY *pk))
 	{
 	X509_CRL_METHOD *m;
-	m = OPENSSL_malloc(sizeof(X509_CRL_METHOD));
+	m = (X509_CRL_METHOD *)OPENSSL_malloc(sizeof(X509_CRL_METHOD));
 	if (!m)
 		return NULL;
 	m->crl_init = crl_init;
